%define	major	5.1
%define	libname %mklibname lua %{major}

Summary:	Powerful, light-weight programming language
Name:		lua5.1
Version:	5.1.5
Release:	%mkrel 23
License:	MIT
URL:		https://www.lua.org/
Group:		Development/Other
Source0:	https://www.lua.org/ftp/lua-%{version}.tar.gz
Patch1:		lua-5.1-dynlib.patch
Patch2:		lua-5.1-modules_path.patch
# https://bugs.mageia.org/show_bug.cgi?id=14038
Patch3:		lua5.1-5.1.5-upstream-fix-stack-overflow-CVE-2014-5461.patch
BuildRequires:  readline-devel
Requires:	%{libname} = %{version}
Conflicts:	lua < 5.1.4-11
Provides:	lua(abi) = %{major}

%description
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

%package -n	%{libname}
Summary:	Powerful, light-weight programming language
Group:		System/Libraries

%description -n	%{libname}
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package includes the libraries.

%package -n	%{libname}-devel
Summary:	Powerful, light-weight programming language
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
# to have the same provides on all arches
Provides:	lua%{major}-devel = %{version}-%{release}


%description -n	%{libname}-devel
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package contains the headers and development files for lua.


%package -n	%{libname}-devel-static
Summary:	Powerful, light-weight programming language
Group:		Development/Other
Requires:	%{libname}-devel = %{version}
# to have the same provides on all arches
Provides:	lua%{major}-devel-static = %{version}-%{release}
# conflict with other versions
Conflicts:	lua-devel-static

%description -n	%{libname}-devel-static
Lua is a programming language originally designed for extending applications,
but also frequently used as a general-purpose, stand-alone language. Lua
combines simple procedural syntax (similar to Pascal) with powerful data
description constructs based on associative arrays and extensible semantics.
Lua is dynamically typed, interpreted from bytecodes, and has automatic memory
management, making it ideal for configuration, scripting, and rapid
prototyping. Lua is implemented as a small library of C functions, written in
ANSI C, and compiles unmodified in all known platforms. The implementation
goals are simplicity, efficiency, portability, and low embedding cost.

This package contains the headers and development files for lua.


%prep
%setup -q -n lua-%{version}
%autopatch -p1

sed -i -e "s|/usr/local|%{_prefix}|g" Makefile
sed -i -e "s|/lib|/%{_lib}|g" Makefile
sed -i -e "s|/usr/local|%{_prefix}|g" src/luaconf.h
sed -i -e "s|/lib|/%{_lib}|g" src/luaconf.h
sed -i -e "s|/man/man1|/share/man/man1|g" Makefile
sed -i -e "s|\$(V)|%{major}|g" src/Makefile

%build
sed -i 's/-lncurses/-lncursesw/g' */Makefile*
%make_build linux CFLAGS="%{optflags} -fPIC -DLUA_USE_LINUX" MYLDFLAGS="%{ldflags}"
sed -i -e "s#/usr/local#%{_prefix}#" etc/lua.pc
sed -i -e 's/-lreadline -lncurses //g' etc/lua.pc

%install
%make_install INSTALL_TOP=%{buildroot}%{_prefix} INSTALL_LIB=%{buildroot}%{_libdir} INSTALL_MAN=%{buildroot}%{_mandir}/man1 INSTALL_INC=%{buildroot}%{_includedir}/lua-%{major}
install -d %{buildroot}%{_libdir}/lua/%{major}/
install -d %{buildroot}%{_datadir}/lua/%{major}/
install -p -m 644 test/*.lua %{buildroot}%{_datadir}/lua/%{major}/

install -p -m 755 src/liblua.so.%{major}* %{buildroot}%{_libdir}
ln -s liblua.so.%{major} %{buildroot}%{_libdir}/liblua-%{major}.so

mv %{buildroot}%{_libdir}/liblua{,-%{major}}.a

install -d %{buildroot}%{_libdir}/pkgconfig/
install -p -m 644 etc/lua.pc %{buildroot}%{_libdir}/pkgconfig/lua-%{major}.pc

# to avoid conflict with other versions
mv %{buildroot}%{_bindir}/lua %{buildroot}%{_bindir}/lua%{major}
ln -s lua%{major} %{buildroot}%{_bindir}/lua-%{major}
mv %{buildroot}%{_bindir}/luac %{buildroot}%{_bindir}/luac%{major}
ln -s luac%{major} %{buildroot}%{_bindir}/luac-%{major}

# to avoid conflict with other versions
mv %{buildroot}%{_mandir}/man1/lua.1 %{buildroot}/%{_mandir}/man1/lua%{major}.1
mv %{buildroot}%{_mandir}/man1/luac.1 %{buildroot}/%{_mandir}/man1/luac%{major}.1

%triggerun -- lua5.1 < 5.1.5-18
if [[ -e  %{_localstatedir}/lib/alternatives/lua ]]; then
   %{_sbindir}/update-alternatives --remove-all lua 2> /dev/null ||:
fi

%files
%doc COPYRIGHT HISTORY INSTALL README
%doc doc/*.html doc/*.gif
%{_bindir}/lua*%{major}
%dir %{_libdir}/lua/
%{_libdir}/lua/%{major}
%{_datadir}/lua/%{major}/*.lua
%{_mandir}/man1/*

%files -n %{libname}
%{_libdir}/liblua.so.%{major}

%files -n %{libname}-devel
%{_includedir}/lua-%{major}/
%{_libdir}/pkgconfig/lua-%{major}.pc
%{_libdir}/liblua-%{major}.so

%files -n %{libname}-devel-static
%{_libdir}/liblua-%{major}.a


%changelog
* Thu Jun 26 2025 umeabot <umeabot> 5.1.5-23.mga10
+ Revision: 2196364
- Mageia 10 Mass Rebuild

* Fri Mar 18 2022 umeabot <umeabot> 5.1.5-22.mga9
+ Revision: 1797853
- Mageia 9 Mass Rebuild

* Thu Apr 15 2021 wally <wally> 5.1.5-21.mga9
+ Revision: 1715913
- fix updating lua5.1 from mga8 (mga#28773)

* Fri Apr 02 2021 wally <wally> 5.1.5-20.mga9
+ Revision: 1712838
- remove lua-devel conflicts

* Fri Apr 02 2021 wally <wally> 5.1.5-19.mga9
+ Revision: 1712673
- remove lua-rpm-macros requires from devel pkg

* Tue Mar 30 2021 wally <wally> 5.1.5-18.mga9
+ Revision: 1711939
- add binary symlinks for compatibility with other distros
- make devel pkg parallel installable with new lua version
- drop alternatives support
- build with our %%ldflags

* Sun Mar 28 2021 wally <wally> 5.1.5-17.mga9
+ Revision: 1711500
- require lua5.1 and lua-rpm-macros with devel pkg

* Sun Mar 28 2021 wally <wally> 5.1.5-16.mga9
+ Revision: 1711328
- add lua(abi) provides

* Tue Feb 18 2020 umeabot <umeabot> 5.1.5-15.mga8
+ Revision: 1542185
- Mageia 8 Mass Rebuild

* Sat Jan 04 2020 luigiwalser <luigiwalser> 5.1.5-14.mga8
+ Revision: 1475982
- rebuild for readline

* Sun Sep 23 2018 umeabot <umeabot> 5.1.5-13.mga7
+ Revision: 1299367
- Mageia 7 Mass Rebuild

* Tue Jan 02 2018 wally <wally> 5.1.5-12.mga7
+ Revision: 1189324
- rebuild for new readline

* Sun Sep 11 2016 daviddavid <daviddavid> 5.1.5-11.mga6
+ Revision: 1051459
- main package requires the main library

* Tue Feb 09 2016 umeabot <umeabot> 5.1.5-10.mga6
+ Revision: 952576
- Mageia 6 Mass Rebuild

* Mon Mar 09 2015 shlomif <shlomif> 5.1.5-9.mga5
+ Revision: 818189
- fix the installed .so file which was previously empty (due to prev commit).

* Fri Mar 06 2015 pterjan <pterjan> 5.1.5-8.mga5
+ Revision: 817912
- Fix dynlib patch for parallel build

* Sat Oct 18 2014 akien <akien> 5.1.5-7.mga5
+ Revision: 784047
- Upstream patch to fix CVE-2014-5461 (mga#14038)

* Wed Oct 15 2014 umeabot <umeabot> 5.1.5-6.mga5
+ Revision: 748362
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 5.1.5-5.mga5
+ Revision: 682036
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 5.1.5-4.mga4
+ Revision: 530734
- Mageia 4 Mass Rebuild
+ luigiwalser <luigiwalser>
- fix conflict with lua on upgrade from mga2 (mga#10222)

* Sun Jul 28 2013 wally <wally> 5.1.5-3.mga4
+ Revision: 459456
- drop .a files from devel pkg (they're already in static one)

* Sat Jan 12 2013 umeabot <umeabot> 5.1.5-2.mga3
+ Revision: 359074
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jun 08 2012 fwang <fwang> 5.1.5-1.mga3
+ Revision: 257689
- new version 5.1.5

* Wed Jun 06 2012 tv <tv> 5.1.4-12.mga3
+ Revision: 256631
- imported package lua5.1


* Wed Jun 06 2012 Thierry Vignaud <tvignaud@mandriva.com> 5.1.4-12.mga3
- initial release, forked from lua-5.1.14-11.mga2
